
; I2NM-2.ASM  Telephone number overlay file for IMP2 - 08/20/85
;
;
; This file can be edited to make a new library of telephone numbers.
; Each entry must be 34 bytes long.  36 telephone numbers are allowed,
; (A-Z and 0-9).  Follow the format for the library entries already in
; the file.  (Be sure to use spaces, not tabs.)
;
; At least 1 period (.) must precede each phone number in the table.
;
; Room has been left if your phone system requires extra characters such
; as:  1-313-846-6127 rather than the 313-846-6127 used in some areas.
;
;
;	TO USE: First edit this file filling in answers for your own
;		equipment.  Then assemble with ASM.COM or equivalent
;		assembler.
;
;		A>MLOAD IMP2.COM=IMP240.COM,I2NM-1.HEX
;
; NOTE: For those revising the main program, check the location of
;	   NUMBLIB to see if the ORG value used here is correct.  If
;	   not, change as needed.
;
;=======================================================================
;
; 08/20/85 - Added optional delay for dial tone - Irv Hoff
; 06/01/85 - First version for IMP2		- Irv Hoff
;
;=======================================================================
;
;
YES	EQU	0FFH
NO	EQU	0
;
WTDIAL	EQU	5	; Tenths-seconds to wait for dial tone after
			;   busy signal, minimum size redials quicker.
			;   Use 10 for 1 second, 15 for 1-1/2, etc.
XFRSIZ	EQU	16	; File transfer buffer in Kbytes.  Do not make
			;   any larger than BUFSIZ.  16k works fine on
			;   but slowest systems.
;
	ORG	0C00H-50  ;so 'NUMLIB' starts on even page
;
;=======================================================================
;
; Long distance alternate dialing such as MCI, SPRINT, etc.  Must end
; with a '$', use as many commas (2 seconds delay, each) as needed to
; let the alternate dialing code return with a new dial tone.  Fill in
; any character (periods are fine) after the $ to keep number of columns
; to 24, i.e.,	'1234567,,,,12345,,$.....'   --   the first group is the
; MCI or SPRINT access number, the second group is the user number.  A
; small delay is usually required after the billing number also.
;
ALTDIAL1:DB	'xxxxxxx,,,,,,xxxxxxxx,,$'   ;accessed by a < character
ALTDIAL2:DB	'xxxxxxx,,,,,,xxxxxxxx,,$'   ;accessed by a > character
;
;=======================================================================
;
DIALWT:	DB	WTDIAL		; Waits for dial tone after busy signal
SAVSIZ:	DB	XFRSIZ*8	; Can easily change buffer size for file
				;   transfers with DDT for "NUMBLIB-1"
				;   address.
;
;=======================================================================
;
; Phone number library table for auto-dialing.	Each number must be as
; long as"LIBLEN" (EQU at start of program).  Some areas require extra
; characters such as:	1-313-846-7127.  Room is left for those.  Use
; a (<) for alternate dialing system #1, and a (>) for alternate dialing
; System #2.  Either would preceed the actual number, for example:
;
;	DB    'A=Alan Alda..........<123-456-7890'    ;'A'
;
; -	-     -     -	  -	-     -     -	  -	-     -     -
;
; NOTE: At least one dot (.) MUST precede the actual phone number
;
;		'----5---10---15---20---25---30--34'
NUMBLIB:DB	'A=CTBBS Koeln..............8903821' ; 'A'
	DB	'B=WDR KomCom................210515' ; 'B'
	DB	'C=SUNIL Koeln...............387686' ; 'C'
	DB	'D=CREAM0...............02203-33133' ; 'D'
	DB	'E=CREAM2....................394976' ; 'E'
	DB	'F=PRO-NET..............02204-57102' ; 'F'
	DB	'G=Plakat Box...........02234-71292' ; 'G'
	DB	'H=HBK.......................512640' ; 'H'
	DB	'I=BIT-Dschungel.............558336' ; 'I'
	DB	'J=MILKA.....................882898' ; 'J'
	DB	'K=Saturn...................1616284' ; 'K'
	DB	'L=DELA.....................7151740' ; 'L'
	DB	'M=EHA.......................766923' ; 'M'
	DB	'N=P & M.....................251319' ; 'N'
	DB	'O=PAL..................02203-33021' ; 'O'
	DB	'P=MMS..................02204-21530' ; 'P'
	DB	'Q=Magic Mountain.......02236-63371' ; 'Q'
	DB	'R=CAMEL.................02273-2637' ; 'R'
	DB	'S=PAD 300 Bd..................2911' ; 'S'
	DB	'T=PAD 1200 Bd.................2931' ; 'T'
	DB	'U=frei.................xxxx-xxxxxx' ; 'U'
	DB	'V=frei.................xxxx-xxxxxx' ; 'V'
	DB	'W=frei.................xxxx-xxxxxx' ; 'W'
	DB	'X=frei.................xxxx-xxxxxx' ; 'X'
	DB	'Y=frei.................xxxx-xxxxxx' ; 'Y'
	DB	'Z=frei.................xxxx-xxxxxx' ; 'Z'
	DB	'0=frei.................xxxx-xxxxxx' ; '0'
	DB	'1=frei.................xxxx-xxxxxx' ; '1'
	DB	'2=frei.................xxxx-xxxxxx' ; '2'
	DB	'3=frei.................xxxx-xxxxxx' ; '3'
	DB	'4=frei.................xxxx-xxxxxx' ; '4'
	DB	'5=frei.................xxxx-xxxxxx' ; '5'
	DB	'6=frei.................xxxx-xxxxxx' ; '6'
	DB	'7=frei.................xxxx-xxxxxx' ; '7'
	DB	'8=frei.................xxxx-xxxxxx' ; '8'
	DB	'9=frei.................xxxx-xxxxxx' ; '9'
	DB	0		; End
;		'----5---10---15---20---25---30--34'
;
;;;;	END
;
; NOTE: IF YOU DO NOT (REPEAT DO NOT) WANT THE FUNCTION KEY ASSIGNMENTS
;	BELOW TO GO INTO THE PROGRAM AT THE SAME TIME, REMOVE THE SEMI-
;	COLONS SO THE WORD "END" IS ACTIVATED.	IF THE SEMICOLONS ARE
;	NOT THERE AT PRESENT, ADDING A FEW AHEAD OF THE "END" LINE WILL
;	ALLOW THE FUNCTION KEY ASSIGNMENTS TO BE ENTERED.
;
;
; IMP240 function key overlay
;
CIRCUM	EQU	5EH		; Circumflex character displays on CRT
ESC	EQU	1BH		; Escape character, if you prefer
CR	EQU	0DH
;
;
INTCPT:	DB	CIRCUM		; Intercept character (prefix)
;
;
; The total characters, indluding CR, 0, etc. is limited to 256.  Use
; I2FUNC.COM to make fast and easy changes of any or all function key
; assignments.	You can change any of them to suit your own purposes,
; using the ones below as an example.
;
FNCTBL:
KEY1:	DB	0,'USERNAME',CR,0
KEY2:	DB	1,'PASSWORT',CR,0
KEY3:	DB	2,'DIR CPM',CR,0
KEY4:	DB	3,'L *',CR,0
KEY5:	DB	4,'B *',CR,0
KEY6:	DB	5,'NUI ',0
KEY7:	DB	6,'45890010006',CR,0
KEY8:	DB	7,'44400090314',CR,0
KEY9:	DB	8,'45241090832',CR,0
KEY0:	DB	9,'0270448112',CR,0
;
	DS	256-($-FNCTBL)	; Shows characters remaining to 11CA
TBLEND	EQU	$		; The table must terminate by 11CA

	END
