(**********************************************)
(*     (c) Copyright 1987 by Jens Kalski      *)
(**********************************************)
(* Programmmodul  : DM-REN.INC / (26.08.1988) *)
(* Sprache        : TURBO-PASCAL 3.0          *)
(* Computer       : Schneider CPC464          *)
(* Betriebssystem : CP/M 2.2                  *)
(**********************************************)

PROCEDURE Umbenennen(Nr:INTEGER);

(* Hilfstyp fuer Wiederherstellung der Dateiattribute *)
(* Ueberlagert den TURBO-File-Interface-Block         *)
TYPE
  HilfsTyp = RECORD
               Dummy : ARRAY(.0..11.) OF BYTE;            (* Hier unwichtig *)
               FCB   : FCB_Typ;                               (* CP/M - FCB *)
             END;

VAR
  i,                                                   (* Schleifenvariable *)
  Position : INTEGER;                                     (* CursorPosition *)
  c        : CHAR;                                (* Eingabezeichenspeicher *)
  Name1,                                                 (* Arbeitsspeicher *)
  Name2    : Str12;
  Laenge   : BYTE ABSOLUTE Name2;   (* 1.Byte von Name1 enthaelt die Laenge *)
  HilfsFcb : HilfsTyp ABSOLUTE Datei;                     (* siehe Hilfstyp *)

  PROCEDURE ZeigName;                          (* Momentanen Namen anzeigen *)
  BEGIN
    IF Laenge>12 THEN Laenge:=12;          (* Laenge auf 12 Zeichen kuerzen *)
    IF Position>11 THEN Position:=11;         (* Cursorposition korrigieren *)
    CursorXY(Nr,0);
    Write(Name2);                                         (* Namen ausgeben *)
    FOR i:=Laenge TO 11 DO Write(#218);       (* Rest mit Raster auffuellen *)
    CursorXY(Nr,Position);          (* Cursor auf momentane Position setzen *)
  END;

BEGIN
  Name1:=FormName(Nr);                 (* Name ohne Laufwerksangabe sichern *)
  Name2:=Name1;                             (* Kopie in die Arbeitsvariable *)
  Position:=0;                                 (* Cursorposition auf Anfang *)
  CursorAn;
  ZeigName;

  REPEAT                                              (* Bis ENTER oder ESC *)
    c:=LiesZeichen((.^D,^G,^M,^R..^T,^Y,^[,'!'..')',
               '+','-'..'9','@'..']',DEL.));
    CASE c OF
      ^I : BEGIN
             Name2:=Name1;                  (* Alten Namen wiederherstellen *)
             Position:=0;                           (* Cursor zuruecksetzen *)
           END;
      ^S : Position:=(Position + Laenge) MOD Succ(Laenge);    (* Nach links *)
      ^D : Position:=Succ(Position) MOD Succ(Laenge) MOD 12; (* Nach rechts *)
      ^G : Delete(Name2,Succ(Position),1); (* Zeichen unter Cursor loeschen *)
      ^T : Laenge:=Position;            (* Rechts vom Cursor alles loeschen *)
      ^Y : BEGIN                      (* Ganzes Feld l|schen *)
             Laenge:=0; Position:=0;
           END;
      DEL : IF Position>0 THEN BEGIN   (* Zeichen links vom Cursor loeschen *)
              Delete(Name2,Position,1);
              Position:=Pred(Position);
            END;
      ^M,^[ : ;                                         (* Fertig / Abbruch *)
    ELSE                                       (* Buchstaben fuer den Namen *)
      IF Position<11          (* Cursorposition innerhalb des Editierfeldes *)
        THEN IF (Pos('.',Name2)=0) OR (c<>'.')     (* Nur ein Punkt erlaubt *)
          THEN BEGIN
            IF Position<=Laenge
              THEN Insert(c,Name2,Succ(Position))   (* Wenn Cursor im Namen *)
              ELSE Name2:=Name2+c;                   (* Wenn Cursor am Ende *)
            Position:=Succ(Position) MOD 12;               (* Cursor weiter *)
          END
          ELSE                                      (* Keinen zweiten Punkt *)
        ELSE Insert(c,Name2,12);               (* Zeichen am Ende einfuegen *)
    END;
    ZeigName;
  UNTIL c IN (.^M,^[.);
  CursorAus;

  IF (c<>^[) AND (Name1<>Name2) THEN BEGIN             (* Namensaenderung ? *)
    Assign(Datei,Name2);                       (* Neuen Dateinamen anmelden *)
    IF OeffneDatei
      THEN BEGIN                                   (* Datei existiert schon *)
        Close(Datei);
        DialogZeile('Es existiert schon eine Datei '+Name2+
                    '. (ENTER/ESC)',Nein);
        c:=LiesZeichen((.^M,^[.));
      END
      ELSE BEGIN                              (* Datei existiert noch nicht *)
        Assign(Datei,Name1);                    (* Alten Dateiname anmelden *)
        BDOS(30,Addr(Dat(.Nr.).FCB));            (* Dateiattribute loeschen *)
        ReName(Datei,Name2);
        WITH Dat(.Nr.) DO BEGIN     (* Alte Dateiattribute wiederherstellen *)
          Move(HilfsFCB.FCB,FCB,12);           (* TURBO-FIB-FCB uebernehmen *)
          Bit7(FCB.Name(.8.),NurLesen);                           (* $R/O ? *)
          Bit7(FCB.Name(.9.),Verdeckt);                           (* $SYS ? *)
          BDOS(30,Addr(FCB));                      (* Dateiattribute setzen *)
        END;
      END;
  END;
  LoeschDialogZeile;
END;
