(******************************************)
(*   (c) Copyright 1987 by Jens Kalski    *)
(******************************************)
(* Programm       : DM.PAS / (26.08.1988) *)
(* Sprache        : TURBO-PASCAL 3.0      *)
(* Computer       : Schneider CPC464      *)
(* Betriebssystem : CP/M 2.2              *)
(******************************************)
(*$U-,C-,A+*)

PROGRAM DM;

CONST Version : STRING(.35.) = 'DM / Version 5.1 / (C) JENS KALSKI';
VAR   VLaenge : BYTE ABSOLUTE Version;

CONST
  DEL     = #127;                                   (* ASCII-Zeichen DELETE *)
  Ja      = TRUE;                              (* Einige BOOLEAN-Konstanten *)
  Nein    = FALSE;
  An      = TRUE;
  Aus     = FALSE;
  Ein     = An;
  MaxOpt  = 9;                      (* Anzahl der anwaehlbaren Optionen - 1 *)
  MaxDat  = 127;              (* Maximale Anzahl der anzeigbaren Dateinamen *)
  ZeigSYS : BOOLEAN = Nein;                        (* $SYS-Dateien anzeigen *)
  ZeigRO  : BOOLEAN = Nein;                        (* $R/O-Dateien anzeigen *)
  Option  : INTEGER = 0;      (* Option am Anfang auf "Laufwerk auswaehlen" *)
  OptSave : INTEGER = MaxOpt;
  Invers  : ARRAY(.BOOLEAN.)                (* Farben umschalten oder nicht *)
              OF CHAR = (^@,^X);                                  (* CPC464 *)
  Status  : ARRAY(.BOOLEAN,0..2.)                       (* $SYS-$R/O-Status *)
              OF CHAR = ('aus','an ');
  RamDisk : ARRAY(.BOOLEAN,0..7.)                           (* Laufwerksart *)
              OF CHAR = ('RAM-Disk','Diskette');

TYPE
  FCB_Typ = RECORD      (* Anfang eines CP/M-FCB / Rest wird nicht ben|tigt *)
              Lwk    : BYTE;
              Name   : ARRAY(.0..10.) OF CHAR;
              Extent : BYTE;
              Intern : INTEGER;
            END;

  ALV_Typ = ARRAY(.0..127.) OF BYTE;          (* CP/M-Blockbelegungstabelle *)
  PufferT = ARRAY(.0..300.) OF ALV_Typ;   (* Blockpuffer fuer Kopiervorgang *)

  DPB_Typ = RECORD                          (* CP/M-Diskettenparameterblock *)
              SPT                  : INTEGER;
              BSH,BLM,EXM          : BYTE;
              DSM,DRM,AL01,CKS,OFF : INTEGER;
            END;

  Dir_Typ = RECORD                            (* Inhaltsverzeichnisspeicher *)
              Verdeckt,                 (* TRUE = $SYS / FALSE = nicht $SYS *)
              NurLesen : BOOLEAN;       (* TRUE = $R/O / FALSE = nicht $R/O *)
              FCB      : FCB_Typ;                     (* CP/M-FCB der Datei *)
            END;

  Lfw_Typ = RECORD CASE INTEGER OF        (* Speicher vorhandener Laufwerke *)
              0 : (I : INTEGER);
              1 : (S : SET OF 0..15);
            END;

  SoC     = SET OF CHAR;
  Str2    = STRING(.2.);
  Str12   = STRING(.12.);
  Str25   = STRING(.25.);
  Str78   = STRING(.78.);

CONST
  All_FCB : FCB_Typ = ( Lwk:0;         (* CP/M-FCB zum Suchen aller Dateien *)
                        Name:'???????????';
                        Extent:0;
                        Intern:0 );

VAR
  c          : CHAR;           (* Allgemeiner Speicher f}r Tastatureingaben *)

  JN,                                              (* Fuer Ja/Nein-Abfragen *)
  Flag,
  ZweiteSeite : BOOLEAN;                           (* Mehr als 64 Dateien ? *)

  DMA_Nr,                         (* 0..3/255 fuer Diskettenpuffer CP/M-DMA *)
  i,j,                                          (* Allgemeine Hilfsvariable *)
  Frei,                                    (* Freier Diskettenspeicherplatz *)
  Seite,                                                    (* Seitennummer *)
  Zaehler,                                                 (* Dateienanzahl *)
  PufferGroesse,                               (* Groesse des Kopierpuffers *)
  Lwk1,Lwk2,                                            (* Laufwerk 1 und 2 *)
  Dat1,Dat2      : INTEGER;                              (* Menuepositionen *)

  Anfang,
  Ende,
  Anzahl     : ARRAY(.0..1.) OF BYTE;

  Laufwerke  : Lfw_Typ;                         (* Angeschlossene Laufwerke *)

  DPB        : ^DPB_Typ;         (* Zeiger auf CP/M-Diskettenparameterblock *)
  ALV        : ^ALV_Typ;           (* Zeiger auf CP/M-Blockbelegungstabelle *)
  Puffer     : ^PufferT;                         (* Zeiger auf Kopierpuffer *)

  Dat        : ARRAY(.0..MaxDat.) OF Dir_Typ; (* Inhaltsverzeichnisspeicher *)
  Markiert   : ARRAY(.0..MaxDat.) OF BOOLEAN;         (* Dateikennzeichnung *)
  DMA        : ARRAY(.0..3,0..31.) OF CHAR;       (* CP/M - Diskettenpuffer *)

  Datei      : FILE;

(*$I DM-UTIL.INC*)
(*$I DM-COPY.INC*)
(*$I DM-REN.INC*)

BEGIN
  PufferGroesse:=MemAvail SHR 7;                (* Puffergroesse berechnen. *)
  GetMem(Puffer,PufferGroesse SHL 7);              (* Puffer dimensionieren *)
  Rahmen;                                               (* Bildschirmaufbau *)
  Lwk1:=BDOS(25);                      (* Angemeldetes Laufwerk feststellen *)
  Lwk2:=Lwk1;
  VorhandeneLaufwerke;
  FOR Option:=Pred(MaxOpt) DOWNTO 0 DO            (* Alle Optionen anzeigen *)
    ZeigeOption;

  REPEAT                              (* Wiederholen bis ESC gedrueckt wird *)

    Frei:=0;                     (* Freien Diskettenspeicherplatz berechnen *)
    DPB:=Ptr(BDOSHL(31));           (* Adresse des Diskettenparameterblocks *)
    ALV:=Ptr(BDOSHL(27));              (* Adresse der Blockbelegungstabelle *)
    FOR i:=0 TO DPB^.DSM DO             (* Blockbelegungstabelle auszaehlen *)
      Frei:=Frei + Ord(NOT(TestBit(ALV^(.i SHR 3.),7-(i AND 7))));
    Frei:=(Succ(DPB^.BLM) SHR 3) * Frei;           (* Blockgroesse * Anzahl *)

    (* Disketteninhaltsverzeichnis auslesen und speichern *)

    Zaehler:=0;
    FillChar(Dat,Succ(MaxDat)*17,0);             (* Speicher initialisieren *)
    FillChar(Markiert,Succ(MaxDat),0);           (* Speicher initialisieren *)
    BDOS(26,Addr(DMA));                            (* DMA-Adresse festlegen *)
    DMA_Nr:=BDOS(17,Addr(All_FCB));     (* Ersten Verzeichniseintrag suchen *)

    WHILE (DMA_Nr<>255) AND (Zaehler<=MaxDat) DO BEGIN
      WITH Dat(.Zaehler.) DO BEGIN
        Move(DMA(.DMA_Nr.),FCB,15);                    (* CP/M-FCB kopieren *)
        WITH FCB DO BEGIN
          Lwk:=Succ(Lwk1);                   (* Laufwerksnummer uebernehmen *)
          NurLesen:=TestBit(Name(.8.),7);                         (* $R/O ? *)
          Bit7(Name(.8.),Aus);                      (* $R/O-Status loeschen *)
          Verdeckt:=TestBit(Name(.9.),7);                         (* $SYS ? *)
          Bit7(Name(.9.),Aus);                      (* $SYS-Status loeschen *)
        END;
      END;
      Zaehler:=Succ(Zaehler);
      DMA_Nr:=BDOS(18);                        (* Naechsten Eintrage suchen *)
    END;
    Zaehler:=Pred(Zaehler);

    (* Sind mehr Dateien auf der Diskette, als verarbeitet werden koennen ? *)
    IF DMA_Nr<>255 THEN BEGIN
      DialogZeile('WARNUNG : Mehr als 128 Dateien. (Weiter=ENTER)',Nein);
      c:=LiesZeichen((.^M.)); LoeschDialogZeile;
    END;

    IF Zaehler >= 0 THEN BEGIN              (* Wenn Dateien gefunden wurden *)

      Sortiere;                                          (* Namen sortieren *)

      Anfang(.0.):=0;
      ZweiteSeite:=(Zaehler>63);
      IF ZweiteSeite
        THEN BEGIN
          Ende(.0.):=63;
          Anfang(.1.):=64;
          Ende(.1.):=Zaehler;
        END
        ELSE Ende(.0.):=Zaehler;
      Anzahl(.0.):=Ende(.0.)-Anfang(.0.);
      Anzahl(.1.):=Ende(.1.)-Anfang(.1.);

      (* Variablen vorbelegen und Rest des Bildschirms aufbauen *)
      GotoXY(26,2);
      Write(RamDisk(.NormLwk(Lwk1).),FormLwk(Lwk1):3,' /',Succ(Zaehler):3,
            ' Dateien /',Frei:4,' KB frei / Puffer ',Succ(PufferGroesse));

      Option:=0;
      IF OptSave<>0 THEN ZeigeOption;

      Dat1:=0;
      Dat2:=0;
      Seite:=0;
      ZeigAlleDateien;
      Cursor(0,An);
      ZeigStatus(0);

      REPEAT                                          (* Bis ESC oder ENTER *)
        c:=LiesZeichen((.^A,^C..^G,^M,^Q..^S,^V,^X,^[,' ','^',DEL.));

        CASE c OF ^A,^C,^F,^R,^V : MarkierungUmschalten(Dat1); END;

        CASE c OF
          ^E,^R : BEGIN                            (* Dateicursor nach oben *)
                    Dat2:=Dat1-5;
                    IF Dat2<0 THEN
                      WHILE Dat2<Anzahl(.Seite.)-4 DO
                        Dat2:=Dat2+5;
                  END;

          ^X,^C : BEGIN                           (* Dateicursor nach unten *)
                    Dat2:=Dat1+5;
                    IF Dat2>Anzahl(.Seite.) THEN
                      REPEAT
                        Dat2:=Dat2-5;
                      UNTIL Dat2<5;
                  END;

                                                  (* Dateicursor nach links *)
          ^S,^A : Dat2:=(Dat1+Anzahl(.Seite.)) MOD Succ(Anzahl(.Seite.));

                                                 (* Dateicursor nach rechts *)
          ^D,^F : Dat2:=Succ(Dat1) MOD Succ(Anzahl(.Seite.));

          ^Q : CASE LiesZeichen((.'C','D','R','S',^C,^D,^R,^S.)) OF
                 ^S,'S' : BEGIN                 (* Optionscursor nach links *)
                            Option:=(Option + MaxOpt) MOD Succ(MaxOpt);
                            ZeigeOption;
                          END;

                 ^D,'D' : BEGIN                (* Optionscursor nach rechts *)
                            Option:=Succ(Option) MOD Succ(MaxOpt);
                            ZeigeOption;
                          END;

                                            (* Alle Markierungen umschalten *)
                 ^R,'R' : FOR i:=0 TO Zaehler DO MarkierungUmschalten(i);

                 ^C,'C' : BEGIN               (* Alle Markierungen loeschen *)
                            FillChar(Markiert,Succ(MaxDat),0);
                            ZeigAlleDateien;
                          END;
               END;

          ^G : BEGIN                              (* $SYS-Dateien verdecken *)
                 ZeigSYS:=NOT ZeigSYS;
                 GotoXY(14,1);
                 Write(Status(.ZeigSYS.));
                 PruefeSichtbarkeit;
               END;

          DEL : BEGIN                             (* $R/O-Dateien verdecken *)
                  ZeigRO:=NOT ZeigRO;
                  GotoXY(14,2);
                  Write(Status(.ZeigRO.));
                  PruefeSichtbarkeit;
                END;

          '^' : IF ZweiteSeite THEN BEGIN     (* Seite wechseln *)
                  Seite:=(Succ(Seite) AND 1);
                  ZeigAlleDateien;
                END;

          ' ' : BEGIN         (* Bildschirm dunkel schalten bis Tastendruck *)
                  FuelleFarbRegister(1,0,0);
                  BildschirmRandFarbe(0);
                  c:=LiesZeichen((.#0..#255.)); c:=' ';
                  FuelleFarbRegister(1,26,26);
                  BildschirmRandFarbe(6);
                END;

          ^M : BEGIN                       (* Angewaehlte Option ausfuehren *)
                 Cursor(Dat1,Aus);
                 CASE Option OF
                   0 : BEGIN          (* Neues Laufwerk/Diskette auswaehlen *)
                         LaufwerksWahl;
                         Lwk1:=Lwk2;
                         SetzeLaufwerk(Lwk1,NormLwk(Lwk1));
                       END;

                   1 : IF Markierungen THEN BEGIN       (* Dateien loeschen *)
                         DialogZeile('RICHTIG ? / Schreibschutz aus ?',Ja);
                         IF JaNein(Ja) THEN
                           FOR i:=0 TO Zaehler DO
                             IF Markiert(.i.) THEN
                               BDOS(19,Addr(Dat(.i.).FCB));     (* Loeschen *)
                       END;

                   3 : IF Markierungen THEN BEGIN       (* Dateien kopieren *)
                         DialogZeile('RICHTIG ?',Ja);
                         IF JaNein(Ja) THEN REPEAT              (* Bis NEIN *)
                           JN:=Nein;
                           LaufwerksWahl;        (* Ziellaufwerk auswaehlen *)
                           IF NormLwk(Lwk1) OR (Lwk1<>Lwk2) THEN
                             IF (Kopie AND NormLwk(Lwk2)) THEN BEGIN
                               DialogZeile('Noch eine Kopie ?',Ja);
                               JN:=JaNein(Nein);
                             END;
                         UNTIL NOT JN;
                       END;

                   2,4 : BEGIN
                           Flag:=Nein;
                           FOR i:=0 TO Zaehler DO
                             IF Sichtbar(i) THEN
                               IF Copy(Dat(.i.).FCB.Name,9,3) = 'BAK' THEN
                                 CASE Option OF
                                   2 : BEGIN
                                         Flag:=Ja;
                                         Markiert(.i.):=TRUE;
                                         ZeigDatei(i);
                                       END;
                                   4 : FOR j:=0 TO Zaehler DO
                                         IF j <> i THEN IF Sichtbar(j) THEN
                                           IF Copy(Dat(.i.).FCB.Name,1,8) =
                                              Copy(Dat(.j.).FCB.Name,1,8) THEN
                                             IF Copy(Dat(.j.).FCB.Name,9,3) <> 'BAK'
                                               THEN BEGIN
                                                 Flag:=Ja;
                                                 Markiert(.j.):=TRUE;
                                                 ZeigDatei(j);
                                               END;
                                 END;
                           Cursor(Dat1,An);
                           Option:=Pred(Option) * Ord(Flag);
                           ZeigeOption;
                           c:=#0;
                         END;

                   5 : IF Sichtbar(Dat1)      (* Datei im Cursor umbenennen *)
                         THEN IF SchreibschutzAus(Lwk1)
                           THEN Umbenennen(Dat1);

                          (* Dateiattribute aller markierten Dateien setzen *)
                   6..9 : IF Markierungen THEN
                            IF SchreibschutzAus(Lwk1) THEN
                              FOR i:=0 TO Zaehler DO
                                WITH Dat(.i.) DO IF Markiert(.i.) THEN BEGIN
                                  Bit7(FCB.Name(.8.),(Option<>8) AND
                                    (NurLesen OR (Option=9)));
                                  Bit7(FCB.Name(.9.),(Option<>6) AND
                                    (Verdeckt OR (Option=7)));
                                  BDOS(30,Addr(FCB));     (* Attribute setzen *)
                                END;

                 END;
               END;
        END;

        IF Dat1<>Dat2 THEN BEGIN       (* Cursor auf neue Position setzen ? *)
          Cursor(Dat1,Aus);                     (* Alten Cursor ausschalten *)
          Cursor(Dat2,An);                      (* Neuen Cursor ausschalten *)
          Dat1:=Dat2;
          ZeigStatus(Dat1);
        END;

      UNTIL c IN (.^M,^[.);
    END

    ELSE BEGIN                                          (* Wenn Zaehler < 0 *)
      DialogZeile('Keine Dateien auf Laufwerk '+FormLwk(Lwk1)+
                  ' (ENTER/ESC)',Nein);
      c:=LiesZeichen((.^M,^[.));
      IF c = ^M THEN BEGIN (* Wenn ENTER -> Neues Laufwerk/Diskette waehlen *)
        LaufwerksWahl;
        Lwk1:=Lwk2;
        SetzeLaufwerk(Lwk1,NormLwk(Lwk1));
      END;
    END;

  UNTIL c = ^[;

  CrtExit;

END.
