(***********************************************)
(*      (c) Copyright 1987 by Jens Kalski      *)
(***********************************************)
(* Programmmodul  : DM-UTIL.INC / (26.08.1988) *)
(* Sprache        : TURBO-PASCAL 3.0           *)
(* Computer       : Schneider CPC464           *)
(* Betriebssystem : CP/M 2.2                   *)
(***********************************************)

PROCEDURE CursorAus;                     (* CPC464 / Textcursor ausschalten *)
BEGIN Write(^B); END;

PROCEDURE CursorAn;                      (* CPC464 / Textcursor einschalten *)
BEGIN Write(^C); END;

(* CPC464 / Farbregister mit Farbe fuellen *)
PROCEDURE FuelleFarbRegister(FarbRegisterNummer,Farbe1,Farbe2:INTEGER);
BEGIN Write(^\,Chr(FarbRegisterNummer),Chr(Farbe1),Chr(Farbe2)); END;

PROCEDURE BildschirmRandfarbe(Farbe:INTEGER);                     (* CPC464 *)
BEGIN Write(^],Chr(Farbe),Chr(Farbe)); END;

FUNCTION IO_Flag:BOOLEAN;                      (* TRUE=OK / FALSE=IO-Fehler *)
BEGIN IO_Flag:=(IOResult=0); END;

FUNCTION OeffneDatei:BOOLEAN;      (* Datei mit Fehlerabfrage zuruecksetzen *)
BEGIN
  (*$I-*) Reset(Datei); (*$I+*)
  OeffneDatei:=IO_Flag;
END;

FUNCTION NormLwk(Lwk:INTEGER):BOOLEAN;          (* Ist Lwk keine RAM-Disk ? *)
BEGIN NormLwk:=(Lwk <> 2); END;

PROCEDURE Rahmen;                                       (* Bildschirmaufbau *)
CONST
  ws      = #154;                           (* Waagerechter Strich / CPC464 *)
  ss      = #149;                            (* Senkrechter Strich / CPC464 *)
  Trenner = #149^H^J#149^H^J#155;
VAR
  i : INTEGER;                                             (* Hilfsvariable *)

  (* Waagerechter Strich in Zeile ZEILE *)
  PROCEDURE Strich(Zeile:INTEGER);
  VAR i : INTEGER;
  BEGIN GotoXY(1,Zeile); FOR i:=1 TO 80 DO Write(ws); END;

BEGIN
  CrtInit; ClrScr;                             (* Bildschirm initialisieren *)
  CursorAus;
  FuelleFarbRegister(0,0,0);                (* Farbregister 0 = ganz dunkel *)
  FuelleFarbRegister(1,26,26);                (* Farbregister 1 = ganz hell *)
  Bildschirmrandfarbe(6);
  Write(^N,#0);                         (* CPC464 / Hintergrundfarbe dunkel *)
  Write(^O,#1);                               (* CPC464 / Schriftfarbe hell *)
  Strich(3); Strich(5); Strich(7);
  GotoXY(17,1); Write(Trenner);                      (* Senkrechter Trenner *)
  GotoXY(1,1);  Write('$SYS-Dateien ',Status(.ZeigSYS.));
  GotoXY(1,2);  Write('$R/O-Dateien ',Status(.ZeigRO.));
  GotoXY((99-VLaenge) SHR 1,1); Write(Version);
END;

PROCEDURE LoeschDialogZeile;
BEGIN GotoXY(1,4); ClrEol; END;

PROCEDURE DialogZeile(Meldung:Str78;JN:BOOLEAN);
VAR Laenge : BYTE ABSOLUTE Meldung;
BEGIN
  LoeschDialogZeile;
  GotoXY(Succ((80-Laenge-(Ord(JN)*10)) SHR 1),4);
  Write(Meldung);
END;

FUNCTION TestBit(VAR t;b:INTEGER):BOOLEAN;          (* Bit b in t gesetzt ? *)
VAR TestVar : SET OF 0..7 ABSOLUTE t;
BEGIN TestBit:=(b IN TestVar); END;

PROCEDURE Bit7(VAR T;F:BOOLEAN);        (* F? -> Bit 7 in T setzen/loeschen *)
VAR
  hT : BYTE ABSOLUTE T;
  hF : BYTE ABSOLUTE F;
BEGIN hT:=(hT OR 128) XOR ((NOT hF) SHL 7); END;

FUNCTION LiesZeichen(Erlaubt:SoC):CHAR;   (* Zeichen von der Tastatur lesen *)
VAR c : CHAR;
BEGIN
  REPEAT
    Read(KBD,c);                               (* Lese Zeichen von Tastatur *)
    c:=UpCase(c);                         (* Nur gro~e Buchstaben benoetigt *)
  UNTIL c IN Erlaubt;
  LiesZeichen:=c;
END;

FUNCTION JaNein(Default:BOOLEAN):BOOLEAN;         (* (J)a / (N)ein abfragen *)
CONST
  JANE : ARRAY(.BOOLEAN.) OF CHAR = ('N','J');
VAR
  c : CHAR;
BEGIN
  JaNein:=Default;
  Write(' (J/N) <',JANE(.Default.),'>');
  c:=LiesZeichen((.^M,^[,'J','N','Y'.));
  IF NOT(c IN (.^M,^[.)) THEN JaNein:=(c IN (.'J','Y'.));
  LoeschDialogZeile;
END;

FUNCTION SchreibschutzAus(Drive:INTEGER):BOOLEAN;
BEGIN
  SchreibschutzAus:=Ja;
  IF NormLwk(Drive) THEN BEGIN                       (* Wenn keine RAM-Disk *)
    DialogZeile('Schreibschutz aus ?',Ja);
    SchreibschutzAus:=JaNein(Ja);
  END;
END;

PROCEDURE CursorXY(Nr,Addx:INTEGER);         (* Position im Menue berechnen *)
BEGIN GotoXY(((Nr MOD 5) SHL 4 + 3 + Addx),(Nr DIV 5 + 9)); END;

PROCEDURE Cursor(Nr:INTEGER;Zeig:BOOLEAN);           (* Menue-Cursor setzen *)
CONST
  CursorSymbolL : ARRAY(.BOOLEAN.) OF CHAR = (' ',#246);
  CursorSymbolR : ARRAY(.BOOLEAN.) OF CHAR = (' ',#247);
BEGIN
  CursorXY(Nr,-1); Write(CursorSymbolL(.Zeig.));           (* Vor dem Namen *)
  CursorXY(Nr,12); Write(CursorSymbolR(.Zeig.));        (* Hinter dem Namen *)
END;

FUNCTION Sichtbar(Nr:INTEGER):BOOLEAN; (* Datei sichtbar o.r ausgeblendet ? *)
BEGIN
  WITH Dat(.Nr.) DO
    Sichtbar:=(ZeigSYS OR NOT Verdeckt) AND
              (ZeigRO  OR NOT NurLesen);
END;

PROCEDURE ZeigDatei(Nr:INTEGER);          (* Bestimmten Dateinamen anzeigen *)
BEGIN
  IF Nr >= Anfang(.Seite.) THEN
    IF Nr <= Ende(.Seite.) THEN BEGIN
      CursorXY(Nr-Anfang(.Seite.),0);
      WITH Dat(.Nr.) DO BEGIN
        Write(Invers(.Markiert(.Nr.).));              (* Hell oder dunkel ? *)
        IF Sichtbar(Nr)
          THEN Write(Copy(FCB.name,1,8),Copy(FCB.name,9,3):4) (* Anzeigen ! *)
          ELSE Write('------------');                        (* Verdecken ! *)
        Write(Invers(.Markiert(.Nr.).));              (* Hell oder dunkel ? *)
      END;
    END;
END;

(* Markierung in Abhaengigkeit vom momentanen Status umschalten oder nicht *)
PROCEDURE MarkierungUmschalten(Nr:INTEGER);
BEGIN
  WITH Dat(.Nr.) DO Markiert(.Nr.):=Markiert(.Nr.) XOR
    NOT( (NOT Sichtbar(Nr)) OR
         ((Option IN (.1,2.)) AND NurLesen AND NOT Markiert(.Nr.)) );
  ZeigDatei(Nr);
END;

PROCEDURE ZeigAlleDateien;
VAR i : INTEGER;                                           (* Hilfsvariable *)
BEGIN
  FOR i:=0 TO Anzahl(.Seite.) DO                     (* Alle Namen anzeigen *)
    ZeigDatei(i+Anfang(.Seite.));
  CursorXY(Succ(Anzahl(.Seite.)),-3);          (* Cursor nach letztem Namen *)
  Write(^T);
END;

PROCEDURE PruefeSichtbarkeit;
VAR i : INTEGER;
BEGIN
  FOR i:=0 TO Zaehler DO
    IF NOT Sichtbar(i) THEN
      IF Markiert(.i.) THEN
        Markiert(.i.):=Nein;
  ZeigAlleDateien;
END;

PROCEDURE ZeigStatus(Nr:INTEGER);                (* Dateiattribute anzeigen *)
BEGIN
  WITH Dat(.Nr.) DO BEGIN
    GotoXY(1,1); Write(Invers(.Verdeckt.),'$SYS',Invers(.Verdeckt.));
    GotoXY(1,2); Write(Invers(.NurLesen.),'$R/O',Invers(.NurLesen.));
  END;
END;

PROCEDURE ZeigeOption;        (* Neu angew{hlte Option zeigen (hervorheben) *)

  PROCEDURE SchreibOption(Nr:INTEGER;HD:BOOLEAN);
  CONST
    Optionen : ARRAY(.0..MaxOpt.) OF STRING(.8.) =              (* Optionen *)
              (' DRIVE ',' ERASE ',' ERABAK ',' COPY ',' SAVE ',
               ' RENAME ',' $DIR ',' $SYS ',' $R/W ',' $R/O ');
    Position : ARRAY(.0..MaxOpt.) OF BYTE =       (* Horizontale Positionen *)
              (8,15,22,30,36,42,50,56,62,68);
  BEGIN
    GotoXY(Position(.Nr.),6);
    Write(Invers(.HD.),Optionen(.Nr.),Invers(.HD.));
  END;

BEGIN
  SchreibOption(OptSave,Aus);                         (* Alte Option dunkel *)
  SchreibOption(Option,An);                              (* Neu Option hell *)
  OptSave:=Option;                                 (* Optionsnummer sichern *)
END;

PROCEDURE VorhandeneLaufwerke;
VAR
  i  : INTEGER;
  hL : Lfw_Typ;
BEGIN
  hL.I:=BDOSHL(24);
  Laufwerke.I:=0;
  FOR i:=0 TO 15 DO
    IF (.i.) <= hL.S
      THEN IF BIOSHL(8,i) <> 0
        THEN Laufwerke.S:=Laufwerke.S + (.i.);
  i:=BIOSHL(8,Lwk1);
END;

PROCEDURE SetzeLaufwerk(Drive:INTEGER;LwkReset:BOOLEAN);
BEGIN
  IF LwkReset THEN BDOS(13);               (* Diskettensystem zuruecksetzen *)
  BDOS(14,Drive);                     (* Laufwerk zum Bezugslaufwerk machen *)
END;

FUNCTION FormLwk(Lwk:INTEGER):Str2;     (* String mit Laufwerk und : bilden *)
BEGIN FormLwk:=Chr(Lwk+65)+':'; END;

FUNCTION FormName(Nr:INTEGER):Str12;         (* String mit Dateiname bilden *)
VAR
  i           : INTEGER;                                   (* Hilfsvariable *)
  HilfsString : Str12;                                     (* Hilfsvariable *)
BEGIN
  HilfsString:=Dat(.Nr.).FCB.Name;
  Insert('.',HilfsString,9);                             (* Punkt einfuegen *)
  i:=Pos(' ',HilfsString);                        (* Leerzeichen im Namen ? *)
  WHILE i>0 DO BEGIN                   (* Solange Leerzeichen im Namen sind *)
    Delete(HilfsString,i,1);                        (* Leerzeichen loeschen *)
    i:=Pos(' ',HilfsString);                      (* Leerzeichen im Namen ? *)
  END;
  FormName:=HilfsString;
END;

PROCEDURE LaufwerksWahl;
VAR
  CLwk : CHAR;                                             (* Hilfsvariable *)
  i    : INTEGER;                                          (* Hilfsvariable *)
BEGIN
  REPEAT
    GotoXY(9,4);
    FOR i:=0 TO 15 DO                  (* Alle Laufwerke A: bis P: anzeigen *)
      Write(Invers(.Lwk2=i.),FormLwk(i):3,' ',Invers(.Lwk2=i.));
    CLwk:=LiesZeichen((.^S,^D,^M,^[.));      (* Links/Rechts/Fertig/Abbruch *)
    REPEAT
      CASE CLwk OF
        ^S : Lwk2:=(Lwk2+14) AND 15;          (* Laufwerkscursor nach links *)
        ^D : Lwk2:=Succ(Lwk2) AND 15;        (* Laufwerkscursor nach rechts *)
      END;
    UNTIL Lwk2 IN Laufwerke.S;   (* Zeigt Cursor auf vorhandenes Laufwerk ? *)
  UNTIL CLwk IN (.^M,^[.);
  IF CLwk = ^[ THEN Lwk2:=Lwk1;             (* Wenn ESC dann altes Laufwerk *)
  LoeschDialogZeile;
END;

FUNCTION Markierungen:BOOLEAN;           (* Irgendwelche Dateien markiert ? *)
VAR i : INTEGER;
BEGIN
  Markierungen:=Nein;
  FOR i:=0 TO Zaehler DO BEGIN
    IF Markiert(.i.) THEN BEGIN
      Markierungen:=Ja;
      EXIT;
    END;
  END;
END;

(* Nichtrekursiver Sortieralgorithmus *)
PROCEDURE Sortiere;
VAR
  I,J,K    : INTEGER;
  Zwischen : Dir_Typ;
BEGIN
  FOR I:=0 TO Pred(Zaehler) DO BEGIN
    K:=I;
    FOR J:=Succ(I) TO Zaehler DO
      IF Dat(.K.).FCB.name > Dat(.J.).FCB.name THEN K:=J;
    Zwischen:=Dat(.I.);
    Dat(.I.):=Dat(.K.);
    Dat(.K.):=Zwischen;
  END;
END;
