



;****************************************************
;*                                                  *
;*   Menuegesteuertes gegenseitiges Aufrufen von    *
;*                                                  *
;*                CP/M 2.2-Programmen               *
;*                                                  *
;*                  Isar-Amper-Soft                 *
;*                                                  *
;*                    Optionen :                    *
;*                                                  *
;*        Vortex  X - Laufwerk  mit 62 K-CP/M       *
;*                                                  *
;*                    und SP 512                    *
;*                                                  *
;****************************************************
;
cls	equ	12		;Code f}r Bidschirml|schen
;
;*******   BDOS-KONSATANTEN   *************
;
BOOT	EQU	0000H
BDOS	EQU	0005H
FCB	EQU	005CH
CONIO	EQU	06H		;Direkte Konsolen ein-ausgabe
TYPE	EQU	09H		;Zeichenkette ausgeben
OPEN	EQU	0FH		;Datei er|ffnen
CLOSE	EQU	10H		;Datei schliessen
DELETE	EQU	13H		;Datei l|schen
RDSEQU	EQU	14H		;sequentielles Lesen
MAKE	EQU	16H		;Datei erzeugen
SETDMA	EQU	1AH		;Datenpufferadresse w{hlen
WRRAND	EQU	22H		;wahlfreies Schreiben
SIZE	EQU	23H		;Dateigr|sse bestimmen
	ORG	100H
;
;**** Initialisierung: Lokalen Stapel anlegen
;
	lxi	h,0
	dad	sp
	shld	oldstk
	lxi	sp,oldstk
;
;**** Rekursionstiefe bei verschachtelten Menues feststellen

;
	lda	006dh		;Verschachtelungstiefe
	sui	'1'		;ASCII-> direkte Codierung
	cpi	09H		;im Bereich 1 bis 9 ?
	jc	nozero		;nein
	xra	a		;dann Stufe 1
nozero: adi	'1'		;directe Codierung->ASCII
	sta	ebene		;abspeichern
;
;**** Programmliste einlesen
;
	lxi	d,fcb		;hier steht Name der Progliste
	ldax	d		;Laufwerkscode
	ana	a		;Vergleich mit 0
	jnz	select		;bestimmtes Laufwerk vorgegeben
	inr	a		;sonst Laufwerk A>
	stax	d		;(statt Bezugslaufwerk)
select:	mvi	c,open		;Programmliste er|ffnen
	call	bdos		
	inr	a		;Vergleich mit FFh
	jz	nodat		;Datei nicht gefunden
;
;**** (Datenrecords fortlaufend im Speicher ablegen)
;
	lxi	d,text		;Hier wird Datei abgelegt
nxtrec:	push	d
	mvi	c,setdma	;Datenpufferadresse festlegen
	call	bdos
	lxi	d,fcb		;Einen Record einlesen
	mvi	c,rdsequ
	call	bdos
	pop 	d		;alte DMA-Adresse
	lxi	h,0080h		;neue berechnen
	dad	d
	xchg	
	ana	a		;War letztes Lesen erfolgreich ?
	jz 	nxtrec
	mvi	a,1ah		;Dateiende-Kennzeichen anf}gen !
	stax	d
;
;**** Anfangsadressen und L{ngen der Programmlistenzeilen
;****(Textpointerbereich l|schen)
;
	lxi	h,point		
	mvi	b,3ch		;60 Zeichen lang
	xra	a		;mit Null f}llen
clear:	mov	m,a
	inx	h
	dcr	b
	jnz	clear
;
;**** (mit neuen Werten f}llen)
;
	lxi	h,point		;Ablageadresse der Textpointer
	lxi	d,text		;Lage des Textes
	mvi	b,13h		;maximal 19 Zeilen
nxtln:	mov	m,e		;Adresse der Zeile
	inx	h		;in der Pointertabelle ablegen
	mov	m,d
	inx	h
	mvi	c,0ffh		;Zeilenl{nge mit -1 vorbelegen
nxtcha:	inr	c		;Zeilenl{nge erh|hen
	ldax	d		;Zeichen aus der Zeile
	inx	d
	cpi	1ah		;vorzeitiges Textende ?
	jz	txtend
	cpi	0dh		;Zeilenende ?
	jnz	nxtcha
	ldax	d
	cpi	0ah		;Zeilenvorschub }bergehen
	jnz	nolf
	inx	d
nolf:	mvi	a,48h		;72 ist maximale Zeilenl{nge
	cmp	c
	jnc	short
	mov	c,a		;]berschuss nicht beachten
short:	mov	m,c		;Zeilenl{nge in Pointertabelle
	inx	h
	dcr	b		;noch eine Zeile ?
	jnz	nxtln
;
;**** Kopfzeile ausgeben
;**** (Verschachtellungstiefe bei rekursiven Aufrufen ausgeben)
;
txtend:	lxi	d,rectxt	;Kommentar zur Schachteltiefe
	mvi	c,type		;ausgeben
	call	bdos
	lda	ebene		;Wert der Schachteltiefe
	mov	e,a		;Zeichen ausgeben
	call	zeich
	mvi	e,0dh		;Wagenr}cklauf
	call	zeich
;
;**** Titel des Men}s ausgeben
;
	lxi	h,point+2	;L{nge der ersten Zeile
	mvi	a,48h		;Maximale L{nge
	sub	m		;Differenz
	rar			;Halbieren
	mov	b,a
	call	space		;Zeile zentrieren
	lxi	h,point		;Zeiger auf Kopfzeile
	call	string		;Zeile ausgeben
	call	crlf
	mvi	e,'-'		;Zeile unterstreichen
	mvi	b,4fh	
	call	fill		;viele gleiche Zeichen ausgeben
	call	crlf		;1 Leerzeile
	call	crlf
;
;**** L{ngste Menuezeile bestimmen
;
	lxi	b,00ffh
	lxi	h,point+5	;L{nge der ersten Men}zeile
nxtmen:	inr	c		;Anzahl der Men]zeillen
	mov	e,m		;L{nge der ersten Men}zeile
	inx	h
	inx	h
	inx	h
	mov	a,m		;Zugeh|rige Programmzeile
	inx	h
	inx	h
	inx	h
	ana	a		;L{nge 0 ?
	jz	endmen		;Ende des Men}s
	mov	a,e		;Textzeile
	ana	a
	jz	endmen		;Ende des Men}s
	cmp	b		;bisher l{ngste Zeile
	jc	nxtmen		;neue ist k}rzer !
	mov	b,a		;neue l{ngste Zeile
	jmp	nxtmen
endmen:	mov	a,c		;Anzahl der Men}zeilen
	sta	maxi		;Speichern
	mvi	a,48h		;erlaubte maximale L{nge
	sub 	b		;Diefferenz zur tats{chlichen
	rar			;Halbieren
	mov	b,a		;soweit wird einger}ckt
;
;**** Zeilen des Men}s ausgeben
;
	mvi	d,1		;aktuelle Zeile
	lxi	h,point+3	;Pointer auf erste Textzeile
mentxt:	push	b
	call	space		;Ziel zentrieren
	pop	b
	mvi	e,'('
	call	zeich
	mvi	a,'0'		;ASCII-Unwandlung
	add	d		;Zeilennummer
	mov	e,a
	call	zeich		;Ausgeben
	mvi	e,')'
	call	zeich
	push	b
	mvi	b,4		;Abstand zum Text
	call	space
	pop	b
	call	string		;Text der Men}zeile ausgeben
	inx	h		;zugeh|rige Programmzeile
	inx	h		;]berspringen
	inx	h
	call	crlf		;Leerzeile
	call	crlf
	mov	a,d		;aktuelle Zeile
	inr	d		;n{chste
	cmp	c		;letzte Men}zeile ?
	jnz	mentxt		;n{chste Men}zeile
;
;**** Abschlusszeilen des Bildschirmes ausgeben
;
	call	space		;Einr}cken
	push	d
	lxi	d,endmsg	;Endemeldung
	mvi	c,type
	call	bdos
	pop	d
leer:	call	crlf		;2 Leerzeile
	call	crlf
	mov	a,d		;aktuelle Doppelzeile
	inr	d
	cpi	0ah		;Unteres Bildschirmende erreicht
	jnz	leer	
	lxi	d,waimsg	;Eingabeforderung
	mvi	c,type
	call	bdos	
;
;**** Warten bis g}ltige Taste gedr}ckt wird
;
wait:	mvi	e,0ffh		;Direkte Konsoleneingabe
	mvi	c,conio
	call	bdos
	cpi	03h		;Totalabbruch aller Men}stufen
	jz	kill
	mov	e,a		;Ausgabe vorbereiten
	mvi	c,conio
	cpi	'E'		;diese Rekursionsstufe zu Ende
	jz	ende
	cpi	'e'
	jz	ende
	sui	31h		;ASCII-> direkte Codierung
	lxi	h,maxi		;h|chste erlaubte Eingabe
	cmp	m
	jnc	wait		;keine g}ltige Taste
	push 	psw
	call	bdos		;gedr}ckte Taste anzeigen
	pop	psw
;
;**** gew{hlte Programmzeile zur Ausf}hrung bringen
;**** (Pointer der auszuf}hrenden Zeile suchen)
;
	inr	a		;erste ist nie Programmzeile
	add	a		;mal 2
	mov	l,a
	add	a		;mal 4
	add	l		;mal 6
	mov	e,a		;relative Adresse des Pointers
	mvi	d,0
	lxi	h,point		;absolute Pointeradresse
	dad	d
	push	h		;Pointer der Programmzeile
;
;**** (Datei '$$$.SUB' er|ffnen oder erzeugen)
;
	lxi	d,fcbsub	;Versuch , zu er|ffnen
	mvi	c,open		
	call	bdos
	inr	a		;Ist $$$.SUB schon vorhaden ?
	jz	nosub
	lxi	d,fcbsub	;Wenn ja, dann Nummer des ersten
	mvi	c,size		;freien Records bestimmen
	call	bdos
	jmp	subda
nosub:	lxi	d,fcbsub	;'$$$.SUB' erzeugen
	mvi	c,make
	call	bdos
	inr	a
	jz	wrerr		;Disk Write Error
subda:	lxi	d,dma		;Neue DMA-Adresse
	mvi	c,setdma
	call bdos
;
;**** (n{chsten Men}aufruf nach Programmende vorbereiten)
;
	lxi	d,dma+9		;freie Stelle in der DMA
	lxi	h,0082h		;Name der Programmliste
ldir:	mov	a,m		;Name in DMA }bertragen
	cpi	21h
	jc	noldir
	stax	d
	inx	h
	inx	d
	jmp	ldir
noldir:	xchg			;Men}-Aufrufe erg{nzen
	mvi	m,' '		
	inx	h
	lda	ebene		;Rekursionstiefe
	mov 	m,a
	inx	h
	mvi	m,00h		;Zeilenende
	mov	a,l
	sui	(dma+1) and 0ffh;Zeielenl{nge berechnen
	sta	dma		;In DMA-Ablegen
	lxi	d,fcbsub	;DMA in '$$$.SUB' schreiben
	mvi	c,wrrand	;wahlfreier Zugriff
	call 	bdos
	ana	a
	jnz	wrerr
	lhld	fcbsub+21h	;Recordnummer erh|hen
	inx	h
	shld 	fcbsub+21h
;
;**** (Aufruf des gew{hlten Programms in '$$$.SUB' schreiben)
;
	pop	h		;Pointer auf Programmzeile
	mov	e,m		;Adresse auf Programmzeile
	inx	h
	mov	d,m
	inx	h
	mov	b,m		;L{nge der Programmzeile
	lxi	h,dma		;Ziel der Programmzeile
	mov 	m,b
	inx 	h
ldir2:	ldax	d		;Blocktransfer
	mov	m,a
	inx 	h
	inx	d
	dcr	b
	jnz	ldir2
	mvi	m,00h		;Endekenzeichen
;
;**** (Test, ob Programmaufruf ein weiteres Men} ist ?)
;
	lxi	h,mennam	;Text 'MENUE '
	lxi	d,dma+2		;Doppelpunkt bei Laufwerksangabe
	ldax	d
	inx	d		;Zeichen nach Laufwerksangabe
	cpi	':'
	jz	drivea		;keine Laufwerksangabe
	dcx	d		;Name beginnt an erster Stelle
	dcx	d
drivea:	mvi	b,06h		;6 Buchstaben
test:	ldax	d		;Zeichen im Aufruf
	cpi	60h
	jc	gross
	sui	20h		;in Grossbuchstaben umwandeln
gross:	cmp	m		;Vergleiche mit 'MENUE'
	inx	h
	inx	d
	jnz	norec		;kein Rekursiver Aufruf
	dcr	b
	jnz	test
;
;**** (Rekursiver Aufruf eines Untermen}s: Tiefe markieren)
;
	xchg			;HL zeigt in DMA-Bereich
jump:	mov	a,m		;n{chstes Wort }berspringen
	inx	h		;(Nane der Programmliste)
	cpi	21h
	jnc	jump
	dcx	h
	mvi	m,20h		;Leerzeichen anh{ngen
	inx	h
	lda	ebene		;Rekursionsstufe
	inr	a		;n{chstes Men} tiefer verschachteln
	mov	m,a
	inx	h
	mvi	m,00h		;Endekenzeichen
	mov 	a,l
	sui	(dma+1) and 0ffh;L{nge bestimmen
	sta	dma		;In Programmzeile eintragen
;
;**** (Neue Programmzeile in '$$$.SUB' abspeichern)
;
norec:	lxi	d,fcbsub	;Record wahlfrei schreiben
	mvi	c,wrrand
	call 	bdos
	ana	a
	jnz	wrerr		;Disk Write Error
	lxi	d,fcbsub
	mvi	c,close		;'$$$.SUB' schliessen
	call 	bdos
	inr	a
	jz	wrerr		;Fehler
	mvi	e,cls		;Bildschirml|schen
	call	zeich
	jmp	boot		;Warmstart
;
;**** Schreibfehler aufgetreten
;
wrerr:	lxi	d,errtxt	;Fehlermeldung ausgeben
	jmp	error
;
;**** Fehler: Programmliste nicht gefunden
;
nodat:	lxi	d,prgtxt
error:	mvi	c,type
	call	bdos
	jmp	boot
;
;*** Programmende
;
ende:	call	bdos
	mvi	e,cls		;Bildschirml|schen
	call	zeich
	jmp	boot
;
;**** Abbruch aller Programme: '$$$.SUB' und 'XSUB' l|schen
;
kill:	lxi	d,fcbsub	;Dateibeschreiber '$$$.SUB'
	mvi	c,delete	;L|schen
	call 	bdos
	lxi	d,break		;Abbruchmeldung
	mvi	c,type
	call	bdos
	mvi	c,00h		;Warmstart h|chster Priorit{t
	call	bdos		;(l|scht aktiven XSUB-Modus)
;
;*** einzelnes Zeichen an Konsole ausgeben
zeich:	push 	b
	push	d
	push	h
	mvi	c,conio		;direkte Konsolenausgabe
	call	bdos
	pop	h
	pop	d
	pop	b
	ret
;
;**** Text einr}cken
;
space:	mvi	e,20h
;
;**** viele gleiche Zeilen am Bildschirm ausgeben
;
fill:	mvi	c,conio
	push	h
sploop:	push	b
	push	d
	call	bdos
	pop	d
	pop	b
	dcr	b
	jnz	sploop
	pop	h
	ret
;
;**** Zeile aus Programmliste ausgeben
;
string:	push	b
	push	d
	mov	e,m		;HL zeigt auf Variablenpointer
	inx	h
	mov	d,m		;DE enth{lt Stringadresse
	inx	h
	mov	b,m		;B enth{lt Stringl{nge
	inx	h
	push	h		;wird noch ben|tigt
	mov	a,b
	ana	a
	jz	stend
	xchg			;HL enth{lt Stringadresse
	mvi	c,conio
stloop:	mov	e,m		;Zeichen aus String
	inx	h
	push	b
	push	h
	call	bdos
	pop	h
	pop	b
	dcr	b
	jnz	stloop
stend:	pop	h
	pop	d
	pop	b
	ret
;
;**** Wagenr}cklauf und Zeilenvorschub ****
;
crlf:	push	b
	push 	d
	push 	h
	lxi	d,neuln
	mvi	c,type
	call	bdos
	pop	h
	pop	d
	pop	b
	ret
;
;**** Bildschirm-Ausgabestrings
;
neuln:	db	13,10,'$'
rectxt:	db	cls,9,9,9,9,9,9,9,9,'       Ebene: $'
endmsg:	db	'(E)    Menue-Ende',13,10,'$'
waimsg:	db	9,9,9,9,9,9,'    (c) 1985 by Isar-Amper-'
	db	'Soft',13,'Bitte w{hlen Sie: $'
errtxt:	db	13,10,'***** Diskette oder Inhaltsverzeich'
	db	'nis voll *****$'
prgtxt:	db	'***** Datei nicht gefunden *****',13,10,'$'
break:	db	13,10,'***** Menue  Programm abgebrochen '
	db	'*****$'
mennam:	db	'MENUE '
;
;**** Varaiblenbereich
;
fcbsub:	db	1		;Laufwerk A
	db	'$$$     SUB'	;11 Zeichen Programmname
	db	0,0,0,0		;Extentbytes u.s.w
	dw	0,0,0,0		;Blockreservierungen
	dw	0,0,0,0		;16 beliebige Bytes
	db	0,0,0,0		;Recordnummer sequ+wahlfrei
dma:	db	0,'A:MENUE '	;Datenpuffer
;
;**** Dieser Bereich braucht nicht abgespeichert zu werden
;
	ds	120
ebene:	ds	1		;Rekursionstiefe
maxi:	ds	1		;Anzahl der Men}zeilen
point:	ds	3ch		;Variablenpointer (Texte)
	ds	64		;Raum f}r Stack
oldstk:	ds	2		;alter Stackpointer
text:	end



