        ORG     &4000
        LD      HL,&40F2  ;ZEIGER AUF SPEICHER
;                         ;FUER ZEITANGABEN
        LD      B,&03     ;3 ZAHLEN MIT JE
LO:     CALL    &BB06     ;2 ZIFFERN
        RLD               ;EINGEBEN (HH MM SS).
        CALL    &BB06
        RLD
        DEC     HL
        DJNZ    LO
;                         ;AENDERN DES IRQ-PROG.
        DI                ;SYSTEMINTERRUPT AUS.
        LD      HL,NPR    ;ZEIGER AUF NEUEN
;                         ;SPEICHERINHALT
        LD      DE,&B941  ;ZEIGER AUF IRQ-PROG.
        LD      BC,&0003  ;3 SPEICHERSTELLEN
        LDIR              ;WERDEN UMKOPIERT.
        INC     BC        ;TAKTZAEHLER
        LD      (&40F4),BC;AUF 1 SETZEN
        EI                ;SYSTEMINTERRUPT EIN.
        RET               ;FERTIG..........
NPR:    DEFB   &C3,&28,&40;JP &4028
;
;                         ;IRQ-EINSPRUNG
        DI                ;SYSTEMINTERRUPT AUS
        PUSH    AF        ;REGISTER RETTEN
        PUSH    HL
        PUSH    DE
        PUSH    BC
        PUSH    IX
        PUSH    IY
        LD      BC,(&40F4);TAKTZAEHLER LADEN,
        DEC     BC        ;HERUNTERZAEHLEN
        LD      (&40F4),BC;UND ABSPEICHERN
        LD      A,B       ;TAKTZAEHLER
        OR      C         ;AUF 0 ?
        JP      NZ,IRQE   ;WENN NEIN FERTIG.
        LD      BC,&012C  ;SONST WIEDER AUF 300
        LD      (&40F4),BC;HOCHSETZEN.
        LD      HL,&40F0  ;SEKUNDENZAEHLER
        LD      E,&60     ;HOECHSTER WERT.
        CALL    TICK      ;HOCHZAEHLEN UND MIT
;                         ;60 VERGELEICHEN.
        JR      C,UAU     ;ZUR ZEITEINGABE WENN
;                         ;60 NICHT ERREICHT.
        INC     HL        ;SONST MIN.ZAEHLER
        CALL    TICK      ;HOCHZAEHLEN UND
        JR      C,UAU     ;ZUR ZEITAUSGABE WENN
;                         ;60 NICHT ERREICHT.
        INC     HL        ;SONST MIN.ZAEHLER
        LD      E,&24     ;HOCHZAEHLEN UND MIT
        CALL    TICK      ;24 VERGELEICHEN
;                         ;ZEITAUSGABE
UAU:    LD      HL,(&B7C4);BILDSCHIRMOFFSET
        LD      DE,&47    ;ANFANGSPOSITION DER
        ADD     HL,DE     ;ZIFFERNAUSGABE
        LD      A,H       ;AM ENDE DER 1.
        AND     &07       ;ZEILE
        OR      &C0       ;BERECHNEN
        LD      H,A
        PUSH    HL        ;BERECHNETE ADDRESSE
        POP     IY        ;INS IY-REGISTER
        LD      IX,&3980  ;BITMUSTER DER ZIFFERN
        LD      HL,&40F2  ;STUNDENZAEHLER
        LD      DE,&0800  ;FEINZEILENABSTAND
        XOR     A         ;AKKU LOESCHEN
        LD      B,&03     ;3 ZAEHLER
L11:    LD      C,&02     ;MIT JE 2 ZIFFERN
L1:     RLD               ;ZIFFER IN DEN AKKU
        PUSH    AF        ;A ZWISCHENSPEICHERN
        ADD     A,A       ;DIESE 3 BEFEHLE
        ADD     A,A       ;MULTIPLIZIEREN DIE
        ADD     A,A       ;ZIFFER MIT 8 UM DAS
;                         ;RICHTIGE BITMUSTER ZU
;                         ;ERHALTEN
        LD      (LX+2),A  ;ABSPEICHERN NACH DD
;                         ;(ZEILE 112)
        CALL    ZAUS      ;ZIFFERNAUSGABE
        POP     AF        ;AKKU HOLEN
        INC     IY        ;NAECHSTE BILDS.POSITION
        DEC     C         ;BEIDE ZIFFERN
        JP      NZ,L1     ;SCHON AUSGEGEBEN ?
        RLD               ;BYTE WIEDERHERSTELLEN
        INC     IY        ;LEERSTELLE LASSEN
        DEC     HL        ;NAECHSTER ZAEHLER
        DJNZ    L11       ;ZEITAUSGABE FERTIG ?
IRQE:   POP     IY        ;WENN JA, REGISTER
        POP     IX        ;VOM STAPEL HOLEN
        POP     BC
        POP     DE
        POP     HL
        POP     AF
        EX      AF,AF'    ;UEBERSCHRIEBENE
        JP      C,&B978   ;BEFEHLE NACHHOLEN
        JP      &B945     ;UND ZUM SYSTEMIRQ
;
TICK:   LD      A,(HL)    ;ZAEHLERSTAND HOLEN
        INC     A         ;HOCHZAEHLEN
        DAA               ;DEZIMALABGLEICH
        LD      (HL),A    ;ABSPEICHERN
        CP      E         ;HOECHSTSTAND ?
        RET     C         ;WENN NEIN, FERTIG
        XOR     A         ;SONST AUF NULL
        LD      (HL),A    ;ZURUECKSETZEN
        RET               ;FERTIG
;
ZAUS:   PUSH    IY        ;BENUTZTE
        PUSH    IX        ;REGISTER
        PUSH    BC        ;ZWISCHEN SPEICHERN
        LD      BC,&7F8A  ;UNTERES ROM
        OUT     (c),c     ;FREISCHALTEN
LX:     LD      A,(IX+&00);BITMUSTER MIT MODI-
;                         ;FIZIERTEM DD HOLEN
        LD      (IY+&00),A;IN DEN BILDS. SPEICHER
        INC     IX        ;NAECHSTES BYTE
        ADD     IY,DE     ;NAECHSTE FEINZEILE
        JP      NC,LX     ;ZEICHEN FERTIG ?
        LD      BC,&7F8E  ;UNTERES ROM
        OUT     (C),C     ;SPERREN
        POP     BC        ;ALTE REGISTER-
        POP     IX        ;INHALTE
        POP     IY        ;HOLEN
        RET               ;ZUM HAUPTPROGRAMM
        END
;UHR.ASM
        

   LD  